<?php

namespace App\Http\Controllers;

use App\Models\Fact;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class FactController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $facts = Fact::orderBy('created_at', 'desc')->get();
        return response()->json($facts);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $fact = $request->post('fact');
        $newFact = new Fact();
        $newFact->fact = $fact;
        $newFact->save();


        $facts = Fact::orderBy('created_at', 'desc')->get();
        return response()->json($facts);
    }

    public function edit($id){
        $fact = Fact::find($id);
        return response()->json($fact);
    }

    public function update(Request $request, $id){
        $infoFact = $request->post('fact');
        $fact = Fact::find($id);
        $fact->fact = $request->post('fact');
        $fact->save();

        $facts = Fact::orderBy('created_at', 'desc')->get();
        return response()->json($facts);
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $fact = Fact::find($id);
        $fact->delete();

        $facts = Fact::orderBy('created_at', 'desc')->get();
        return response()->json($facts);
    }


    /**
     * Sauvegarde toutes les facts de l'API dans la base de données
     */
    public function saveAllFacts(Request $request){
        $facts = $request->post('allFacts');
        foreach($facts['facts'] as $fact){
            $newFact = new Fact();
            $newFact->fact = $fact;
            $newFact->save();
        }

        $allFacts = Fact::orderBy('created_at', 'desc')->get();

        return response()->json($allFacts);
    }

    /**
     * Génére une fact aléatoirement
     */
    public function factAlea(){
        $nbrFact = Fact::count();
        $rand = rand(1,$nbrFact);
        $facts = Fact::all();
        $i=1;
        foreach($facts as $fact){
            if($i == $rand){
                $getFact = $fact;
            }
            $i++;
        }

        return response()->json($getFact);
    }
}
